class LearningObject::DraftBuilder

  def self.build(publisher, params={})
    @draft = LearningObject.new(sanitize_params(params))
    @draft.state = LearningObject.states[:draft]

    # build topics
    params[:topics].try(:each) do |t|
      @draft.topics << Topic.find(t)
    end

    #build language
    @draft.language = Language.find(params[:language]) if params[:language].to_i > 0

    #build school_level
    @draft.school_level = Topic.find(params[:school_level]) if params[:school_level].to_i > 0

    # set publisher
    @draft.publisher = publisher
    @draft
  end

  def self.sanitize_params(args={})
    new_args = args.clone
    %w(topics language link school_level).each do |arg|
      new_args.delete(arg)
    end
    metadata = { 'dc.object.url' => args[:link] }
    new_args.merge(metadata: metadata)
  end
end
